package com.shanp.widget.wheel;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import java.util.List;

public class WheelAdapter extends BaseAdapter{
	
	private LayoutInflater mInflater;
	private List<WheelItem> mList;
	
	public WheelAdapter(Context context,List<WheelItem> data) {
		this.mInflater = LayoutInflater.from(context);
		this.mList = data;
	}
	
	public void setData(List<WheelItem> data){
		this.mList = data;
		this.notifyDataSetChanged();
	}

	@Override
	public int getCount() {
		if(mList == null){
			return 0;
		}
		return mList.size();
	}

	@Override
	public Object getItem(int position) {
		if(mList == null){
			return null;
		}
		return mList.get(position);
	}

	@Override
	public long getItemId(int position) {
		return position;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		ViewHolder holder = null;
		if(convertView ==null){
			convertView = mInflater.inflate(R.layout.widget_item_wheel_list, parent, false);
			holder = new ViewHolder();
			holder.name = (TextView) convertView;
			convertView.setTag(holder);
		}else{
			holder = (ViewHolder) convertView.getTag();
		}

		WheelItem item = mList.get(position);
		holder.name.setText(item.getName());
		return convertView;
	}
	
	public static class ViewHolder{
		public TextView name;
	}
}
