package com.shanp.base.image;

import android.content.Context;
import android.widget.ImageView;

import com.shanp.base.image.glide.GlideImageLoad;

/**
 * Leexw
 * 17/1/16
 */
public class ImageLoadUtil {

    private static ImageLoad mImageLoad;

    static {
        mImageLoad = new GlideImageLoad();
    }

    public static void load(Context context, String url, ImageView view) {
        load(context, url, view, 0);
    }

    public static void load(Context context, String url, ImageView view, int placeholder) {
        load(context, url, view, placeholder, ImageShowType.CENTER_CROP);
    }

    public static void load(Context context, String url, ImageView view, int placeholder, int... types) {
        mImageLoad.load(context, url, view, placeholder, types);
    }

    public static void load(Context context, String url, ImageView view, ImageSize size, int placeholder, int... types) {
        mImageLoad.load(context, url, view, size, placeholder, types);
    }

    public static void drawable(Context context, int drawableId, ImageView view) {
        drawable(context, drawableId, view, 0);
    }

    public static void drawable(Context context, int drawableId, ImageView view, int placeholder) {
        drawable(context, drawableId, view, placeholder, ImageShowType.CENTER_CROP);
    }

    public static void drawable(Context context, int drawableId, ImageView view, int placeholder, int... types) {
        mImageLoad.drawable(context, drawableId, view, placeholder, types);
    }

    public static void getBitmap(Context context, String url, BitmapTarget target, int... types) {
        mImageLoad.getBitmap(context, url, target, types);
    }

    public static void getBitmap(Context context, String url, ImageSize size, BitmapTarget target, int... types) {
        mImageLoad.getBitmap(context, url, size, target, types);
    }

}
