package com.shanp.base.image.glide;

import android.content.Context;

import com.bumptech.glide.Glide;
import com.bumptech.glide.GlideBuilder;
import com.bumptech.glide.Registry;
import com.bumptech.glide.load.engine.cache.DiskCache;
import com.bumptech.glide.load.engine.cache.ExternalCacheDiskCacheFactory;
import com.bumptech.glide.module.GlideModule;

import java.io.File;

import androidx.annotation.NonNull;

public class GlideConfig implements GlideModule {

    private static final int DISK_CACHE_SIZE = 1024 * 1024 * 1024;
    private static final String CACHE_DIR = File.separator + "cache";

    @Override
    public void applyOptions(@NonNull Context context, @NonNull GlideBuilder builder) {
        DiskCache.Factory factory = new ExternalCacheDiskCacheFactory(context.getApplicationContext(),
                CACHE_DIR, DISK_CACHE_SIZE);
        builder.setDiskCache(factory);
    }

    @Override
    public void registerComponents(@NonNull Context context, @NonNull Glide glide, @NonNull Registry registry) {

    }
}
