package com.shanp.base.rx;

import android.util.Log;

import io.reactivex.subscribers.DisposableSubscriber;

/**
 * Bus订阅者
 *
 * @param <T>
 */
public abstract class EventReceiver<T> extends DisposableSubscriber<T> {

    @Override
    public void onNext(T t) {
        onReceive(t);
    }

    @Override
    public void onError(Throwable e) {
        Log.d("Shanp", "EventReceiver onError: " + e.getMessage());
    }

    @Override
    public void onComplete() {

    }

    public void onReceive(T t) {

    }
}
