package com.shanp.base.util;

import android.text.TextUtils;
import android.util.Base64;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

/**
 * shanpin_lxw
 * 17/2/16
 */

public class Base64Util {

    public static Object toObj(String data) {
        if (TextUtils.isEmpty(data)) {
            return null;
        }
        Object obj = null;
        byte[] userByte = Base64.decode(data, 0);
        ByteArrayInputStream bais = null;
        ObjectInputStream ois = null;
        try {
            bais = new ByteArrayInputStream(userByte);
            ois = new ObjectInputStream(bais);
            obj = ois.readObject();
        } catch (Exception e) {
            e.printStackTrace();
            obj = null;
        } finally {
            try {
                if (bais != null) {
                    bais.close();
                }
                if (ois != null) {
                    ois.close();
                }
            } catch (IOException e) {
                obj = null;
            }
        }
        return obj;
    }

    public static String toBase64(Object obj) {
        if (obj == null) {
            return null;
        }
        String result = null;
        ByteArrayOutputStream baos = null;
        ObjectOutputStream oos = null;
        try {
            baos = new ByteArrayOutputStream();
            oos = new ObjectOutputStream(baos);
            oos.writeObject(obj);
            result = new String(Base64.encode(baos.toByteArray(), 0));
        } catch (IOException e) {
            e.printStackTrace();
            result = null;
        } finally {
            try {
                if (baos != null) {
                    baos.close();
                }
                if (oos != null) {
                    oos.close();
                }
            } catch (IOException e) {
                result = null;
            }
        }
        return result;
    }
}
