package com.shanp.base.util;

import java.security.MessageDigest;

/**
 * MD5 加密工具类
 * @author Leexw
 *
 */
public class EncryptionUtil {

	private static char[] hexChar = { '0', '1', '2', '3', '4', '5', '6', '7',    
		'8', '9', 'a', 'b', 'c', 'd', 'e', 'f' };

	/**
	 * 根据目标字符串，返回MD5加密字符串
	 * @param target 目标字符串
	 * @return 经过MD5加密后的加密字符串（目标字符串为空，返回空字符串）
	 */
	public static String encryption(String target){
		if(target == null || "".equals(target)){
			return "";
		}
		MessageDigest md5 = null;
		try {
			md5 = MessageDigest.getInstance("MD5");
			byte[] buf = target.getBytes();
			md5.update(buf);
			byte[] md5Bytes = md5.digest();
			int len = md5Bytes.length;
			int index = 0;
			char[] c = new char[len*2];
			for(int i = 0;i<len;i++){
				int byte0 = md5Bytes[i];
				c[index++] = hexChar[byte0 >>>4 & 0xf];
				c[index++] = hexChar[byte0 & 0xf];
			}
			return new String(c);
		} catch (Exception e) {
			e.printStackTrace();
			return "";
		}
	}

	/**
	 * 根据字节数组，生成MD5加密字符串
	 * @param buf 字节数组
	 * @return 经过MD5加密后的加密字符串（字节数组为空，返回空字符串）
	 */
	public static String encryption(byte[] buf){
		if(buf == null || "".equals(buf)){
			return "";
		}
		MessageDigest md5 = null;
		try {
			md5 = MessageDigest.getInstance("MD5");
			md5.update(buf);
			byte[] md5Bytes = md5.digest();
			int len = md5Bytes.length;
			int index = 0;
			char[] c = new char[len*2];
			for(int i = 0;i<len;i++){
				int byte0 = md5Bytes[i];
				c[index++] = hexChar[byte0 >>>4 & 0xf];
				c[index++] = hexChar[byte0 & 0xf];
			}
			return new String(c);
		} catch (Exception e) {
			e.printStackTrace();
			return "";
		}
	}
}
