package com.shanp.base.util;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonElement;

import java.lang.reflect.ParameterizedType;
import java.lang.reflect.Type;
import java.util.List;

/**
 * Leexw
 * 17/1/10
 */
public class GsonUtil {

    private static Gson gson;

    static {
        gson = new GsonBuilder()
                .setDateFormat("yyyy-MM-dd HH:mm:ss")
                .create();
    }

    public static String toJson(Object obj) {
        String json = "";
        if (gson != null) {
            json = gson.toJson(obj);
        }
        return json;
    }

    public static <T> T fromJson(String json, Class<T> classOfT) {
        T t = null;
        if (gson != null) {
            t = gson.fromJson(json, classOfT);
        }
        return t;
    }

    public static <T> T fromJson(JsonElement json, Class<T> classOfT) {
        T t = null;
        if (gson != null) {
            t = gson.fromJson(json, classOfT);
        }
        return t;
    }

    public static <T> List<T> fromJsonToList(String json, Class<T> classOfT) {
        List<T> list = null;
        if (gson != null) {
            Type type = type(classOfT);
            list = gson.fromJson(json, type);
        }
        return list;
    }

    public static <T> List<T> fromJsonToList(JsonElement json, Class<T> classOfT) {
        List<T> list = null;
        if (gson != null) {
            Type type = type(classOfT);
            list = gson.fromJson(json, type);
        }
        return list;
    }

    public static ParameterizedType type(final Type... types) {
        return new ParameterizedType() {
            @Override
            public Type getRawType() {
                return List.class;
            }

            @Override
            public Type getOwnerType() {
                return null;
            }

            @Override
            public Type[] getActualTypeArguments() {
                return types;
            }
        };
    }
}
