package com.shanp.share.sharesdk;

import android.content.Context;

import com.mob.MobSDK;
import com.shanp.share.base.BaseShare;
import com.shanp.share.platform.Platform;

import java.util.HashMap;

import cn.sharesdk.framework.Platform.ShareParams;
import cn.sharesdk.framework.ShareSDK;
import cn.sharesdk.sina.weibo.SinaWeibo;
import cn.sharesdk.tencent.qq.QQ;
import cn.sharesdk.tencent.qzone.QZone;
import cn.sharesdk.wechat.friends.Wechat;
import cn.sharesdk.wechat.moments.WechatMoments;

public class ShareSDKShare extends BaseShare {

    public ShareSDKShare(Context context, String key, String secret) {
        //ShareSDK.initSDK(context, sdkid);
        MobSDK.init(context, key, secret);
        ShareSDK.closeDebug();
    }

    public void initWechatFriend(String appid, String appsecret) {
        HashMap<String, Object> wechatMomentsMap = new HashMap<String, Object>();
        wechatMomentsMap.put("Id", "1");
        wechatMomentsMap.put("SortId", "1");
        wechatMomentsMap.put("AppId", appid);
        wechatMomentsMap.put("AppSecret", appsecret);
        wechatMomentsMap.put("BypassApproval", "false");
        wechatMomentsMap.put("Enable", "true");
        ShareSDK.setPlatformDevInfo(WechatMoments.NAME, wechatMomentsMap);
    }

    public void initWechat(String appid, String appsecret) {
        HashMap<String, Object> wechatMap = new HashMap<String, Object>();
        wechatMap.put("Id", "2");
        wechatMap.put("SortId", "2");
        wechatMap.put("AppId", appid);
        wechatMap.put("AppSecret", appsecret);
        wechatMap.put("BypassApproval", "false");
        wechatMap.put("Enable", "true");
        ShareSDK.setPlatformDevInfo(Wechat.NAME, wechatMap);
    }

    public void initQQ(String appid, String appkey) {
        HashMap<String, Object> qqMap = new HashMap<String, Object>();
        qqMap.put("Id", "3");
        qqMap.put("SortId", "3");
        qqMap.put("AppId", appid);
        qqMap.put("AppKey", appkey);
        qqMap.put("ShareByAppClient", "true");
        qqMap.put("Enable", "true");
        ShareSDK.setPlatformDevInfo(QQ.NAME, qqMap);
    }

    public void initQzone(String appid, String appkey) {
        HashMap<String, Object> qzoneMap = new HashMap<String, Object>();
        qzoneMap.put("Id", "4");
        qzoneMap.put("SortId", "4");
        qzoneMap.put("AppId", appid);
        qzoneMap.put("AppKey", appkey);
        qzoneMap.put("ShareByAppClient", "true");
        qzoneMap.put("Enable", "true");
        ShareSDK.setPlatformDevInfo(QZone.NAME, qzoneMap);
    }

    @Override
    public void initSinaWeibo(String appkey, String appsecret) {
        HashMap<String, Object> sinaWeiboMap = new HashMap<String, Object>();
        sinaWeiboMap.put("Id", "5");
        sinaWeiboMap.put("SortId", "5");
        sinaWeiboMap.put("AppKey", appkey);
        sinaWeiboMap.put("AppSecret", appsecret);
        sinaWeiboMap.put("ShareByAppClient", "true");
        sinaWeiboMap.put("Enable", "true");
        ShareSDK.setPlatformDevInfo(SinaWeibo.NAME, sinaWeiboMap);
    }

    @Override
    public void share(Platform platform) {
        //设置分享参数
        ShareParams sp = new ShareParams();
        sp.setTitle(platform.getTitle());
        sp.setText(platform.getText());
        sp.setTitleUrl(platform.getTitleUrl());
        sp.setSite(platform.getSite());
        sp.setSiteUrl(platform.getSiteUrl());
        sp.setImageData(platform.getImageData());
        sp.setImageUrl(platform.getImageUrl());
        sp.setUrl(platform.getUrl());
        sp.setImagePath(platform.getImagePath());
        //设置分享类型
        switch (platform.getShareType()) {
            case Platform.SHARE_URL:
                sp.setShareType(cn.sharesdk.framework.Platform.SHARE_WEBPAGE);
                break;
            case Platform.SHARE_IMG:
                sp.setShareType(cn.sharesdk.framework.Platform.SHARE_IMAGE);
                break;
            case Platform.SHARE_WXMINIPROGRAM:
                sp.setShareType(cn.sharesdk.framework.Platform.SHARE_WXMINIPROGRAM);
                sp.setWxUserName(platform.getWxUserName());
                sp.setWxPath(platform.getPath());
                break;
            default:
                break;
        }
        //设置平台
        cn.sharesdk.framework.Platform sdkplatform = null;
        switch (platform.getPlatform()) {
            case Platform.WECHAT:
                sdkplatform = ShareSDK.getPlatform(Wechat.NAME);
                break;
            case Platform.WECHAT_FRIEND:
                sdkplatform = ShareSDK.getPlatform(WechatMoments.NAME);
                break;
            case Platform.QQ:
                sdkplatform = ShareSDK.getPlatform(QQ.NAME);
                break;
            case Platform.QZONE:
                sdkplatform = ShareSDK.getPlatform(QZone.NAME);
                break;
            case Platform.SINA_WEIBO:
                sdkplatform = ShareSDK.getPlatform(SinaWeibo.NAME);
            default:
                break;
        }
        sdkplatform.share(sp);
    }

}
